##############################################################################
#
# Copyright (c) 2005 Tino Wildenhain.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################
""" Replacement methods for ExceptionFormatter

    Please note it is highly kludgy because its meant as a proof of
    concept and with a minimal change in the current way ExceptionFormatter
    works. This needs a great overhaule as a whole

"""

import os

def TEXTformatLine(self, tb):
    f = tb.tb_frame
    lineno = tb.tb_lineno
    co = f.f_code
    filename = co.co_filename
    name = co.co_name
    locals = f.f_locals
    globals = f.f_globals
    modname = globals.get('__name__', filename)

    s = 'Module %s, line %d' % (modname, lineno)


    revision = self.getRevision(globals)
    if revision:
        s = s + ', rev. %s' % revision

    s = s + ', in %s' % name

    result = []
    result.append("\n"+self.escape(s)+"\n")
    try:
        source=open(filename)

        lb=max(0,lineno-3)
        ub=lineno+2

        for i in range(lb):
            r=source.readline()
        for i in range(lb,ub):
            line=source.readline()
            if not line:
                break
            if (i+1)==lineno:
                result.append("%03d>|%s" % (i+1,line))
            else:
                result.append("%03d |%s" % (i+1,line))
        source.close()
        return result
    except IOError:
        pass
    # Output a traceback supplement, if any.
    if locals.has_key('__traceback_supplement__'):
        # Use the supplement defined in the function.
        tbs = locals['__traceback_supplement__']
    elif globals.has_key('__traceback_supplement__'):
        # Use the supplement defined in the module.
        # This is used by Scripts (Python).
        tbs = globals['__traceback_supplement__']
    else:
        tbs = None
    if tbs is not None:
        factory = tbs[0]
        args = tbs[1:]
        try:
            supp = factory(*args)
            supp.line=lineno
            result.extend(self.formatSupplement(supp, tb))
        except:
            if DEBUG_EXCEPTION_FORMATTER:
                import traceback
                traceback.print_exc()
            # else just swallow the exception.

    try:
        tbi = locals.get('__traceback_info__', None)
        if tbi is not None:
            tbif=self.formatTracebackInfo(tbi)
            if type(tbif)==type([]):
                result.extend(tbif)
            else:
                result.append(tbif)
    except:
        pass
    return result
    return self.line_sep.join(result)

def TEXTformatException(self, etype, value, tb, limit=None):
    # The next line provides a way to detect recursion.
    __exception_formatter__ = 1
    result = [self.getPrefix() + '\n']
    if limit is None:
        limit = self.getLimit()
    n = 0
    while tb is not None and (limit is None or n < limit):
        if tb.tb_frame.f_locals.get('__exception_formatter__'):
            # Stop recursion.
            result.append('(Recursive formatException() stopped)\n')
            break
        line = self.formatLine(tb)
        if type(line)==type([]):
            result.extend(line)
        else:
            result.append(line + '\n')
        tb = tb.tb_next
        n = n + 1
    exc_line = self.formatExceptionOnly(etype, value)
    result.append(self.formatLastLine(exc_line))
    return result


def HTMLformatLineEnscript(self, tb):
    line = TEXTformatLine(self, tb)
    if type(line)==type([]):
        i,o,e=os.popen3("enscript -Epython -p - -w html --color","rw")
        i.write(''.join(line))
        i.close()
        h=o.read() #.split("<PRE>")[1].split("</PRE>")[0]
        o.close()
        e.close()
        if h.find("<PRE>")>-1:
            h=h.split("<PRE>")[1].split("</PRE>")[0]
        else:
            h=''.join(line)
        return '<li><pre>%s</pre></li>' % h
    else:
        return '<li>%s</li>' % line

def HTMLformatLine(self, tb):
    line = TEXTformatLine(self, tb)
    if type(line)==type([]):
        h=''.join(line)
        return '<li><pre>%s</pre></li>' % h
    else:
        return '<li>%s</li>' % line
