##############################################################################
#
# Copyright (c) 2005 Tino Wildenhain.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################
""" Patch for better visual traceback in Zope """

__version__='$Revision: 0.9 $'[11:-2]

import zLOG
from Products.PythonScripts.PythonScript import PythonScriptTracebackSupplement

import os
import zExceptions.ExceptionFormatter

from PythonScriptPatch import getInfo
from ExceptionFormatterPatch import HTMLformatLine,HTMLformatLineEnscript,TEXTformatLine,TEXTformatException
zExceptions.ExceptionFormatter.os=os


# now the patches

PythonScriptTracebackSupplement.getInfo=getInfo
zLOG.LOG("VisualTraceback", zLOG.INFO,"Patch getInfo in Products.PythonScripts.PythonScriptTracebackSupplement")

i,o,e=os.popen3("enscript -V")
if (not o.read()) and e.read():
    zExceptions.ExceptionFormatter.HTMLExceptionFormatter.formatLine=HTMLformatLine
    zLOG.LOG("VisualTraceback", zLOG.INFO,"Patch formatLine in zExceptions.ExceptionFormatter.HTMLExceptionFormatter")
else:
    zExceptions.ExceptionFormatter.HTMLExceptionFormatter.formatLine=HTMLformatLineEnscript
    zLOG.LOG("VisualTraceback", zLOG.INFO,"Patch formatLine with enscript in zExceptions.ExceptionFormatter.HTMLExceptionFormatter")

zExceptions.ExceptionFormatter.TextExceptionFormatter.formatLine=TEXTformatLine
zLOG.LOG("VisualTraceback", zLOG.INFO,"Patch formatline in zExceptions.ExceptionFormatter.TextExceptionFormatter")
zExceptions.ExceptionFormatter.TextExceptionFormatter.formatException=TEXTformatException
zLOG.LOG("VisualTraceback", zLOG.INFO,"Patch formatException in zExceptions.ExceptionFormatter.TextExceptionFormatter")


